*( MERGE.CMD--Create WordPerfect secondary file out of R:BASE)
*( data, merge it into main document, and print it. Requires table)
*( named WPDOCS containing these columns: WPFILE--WordPerfect)
*( document file name, WPDESC--document description, WPTBL--)
*( table or view with the data, and WPCOLS--list of columns to merge.)
*( VDB is the database. VTBL is the table or view holding merge data.)
*( VCOLS is the list of data columns. VORD is the list of sort columns.)
*( VWHR is a string of conditions. VFILE is the main document file.)
*( VSUFFIX is the suffix--WHERE clause, ORDER BY clause, or both.)
CLS
SET MESSAGES OFF
SET ERROR MESSAGES OFF
SET BELL OFF
DEBUG SET MESSAGES ON
DEBUG SET ERROR MESSAGES ON
SET ERROR VAR verr
SET ESCAPE ON
SET NULL -0-
CLEAR VAR vtbl, vcols, vwhr, vfile, vdesc, vord, vsuffix, vdb
SET VAR vtbl TEXT, vcols TEXT, vwhr TEXT, vord TEXT, +
  vdesc TEXT, vfile TEXT, vsuffix TEXT
WRITE 'Choose the database that contains the merge data'
CHOOSE vdb FROM #DATABASES CLEAR FOOTING
IF vdb IS NULL OR vdb IN ('[Esc]','HELP') THEN
  WRITE 'ERROR - You must choose a database.'
  GOTO endoc
ENDIF
CONNECT &vdb
SET NULL -0-
WRITE 'Choose WordPerfect document you want to print:'
CHOOSE vdesc FROM #VALUES FOR wpdesc FROM wpdocs +
  CLEAR FOOTING
IF verr <> 0 THEN
  WRITE 'ERROR - No WordPerfect document table in this database.'
  GOTO endoc
ENDIF
IF vdesc IS NULL OR vdb IN ('[Esc]','HELP') THEN
  WRITE 'ERROR - You must choose a document.'
  GOTO endoc
ENDIF
SELECT wpfile, wptbl, wpcols INTO vfile, vtbl, vcols +
  FROM wpdocs WHERE wpdesc = .vdesc
IF verr <> 0 THEN
  WRITE 'Errors detected, program aborted.'; GOTO endoc
ENDIF
*( Get WHERE clause conditions and ORDER BY columns.)
WRITE 'Choose conditions to limit the rows or press [Esc].'
CHOOSE vwhr FROM #WHERE IN &vtbl CLEAR FOOTING
WRITE 'Choose the columns to sort by or press [Esc].'
CHOOSE vord FROM #COLUMNS IN &vtbl +
  CLEAR FOOTING CHKSORT
*( Create the suffix for DECLARE CURSOR command.)
IF (vwhr IN ('[Esc]','HELP') OR vwhr IS NULL) +
  AND (vord IN ('[Esc]','HELP') OR vord IS NULL) THEN
  SET VAR vsuffix = ' '
ELSE
  IF (vwhr IN ('[Esc]','HELP') OR vwhr IS NULL) THEN
    SET VAR vsuffix = ('ORDER BY' & .vord)
  ELSE
    IF (vord IN ('[Esc]','HELP') OR vord IS NULL) THEN
      SET VAR vsuffix = ('WHERE' & .vwhr)
    ELSE
      SET VAR vsuffix = ('WHERE' & .vwhr & 'ORDER BY' & .vord)
    ENDIF
  ENDIF
ENDIF
*( Build a DECLARE CURSOR structure instead of UNLOAD)
*( because UNLOAD adds extra blanks to DATE values. First,)
*( count the columns in VCOLS for the INTO of FETCH.)
SET VAR vcount INTEGER = 0, vtest TEXT = ' '
WHILE vtest IS NOT NULL THEN
  SET VAR vcount = (.vcount + 1), vtest = (SSUB(.vcols,.vcount))
ENDWHILE
SET VAR vinto TEXT = 'v1 IND vi1', vnum INTEGER = 2
SET VAR vwrite TEXT = 'SET VAR vline TEXT = (.v1'
WHILE vnum < .vcount THEN
  SET VAR vinto = (.vinto + ', v' + (CTXT(.vnum)) +
    & 'IND vi' + (CTXT(.vnum)))
  SET VAR vwrite = (.vwrite & '+ ''#'' + .v' + (CTXT(.vnum)))
  SET VAR vnum = (.vnum + 1)
ENDWHILE
SET VAR vwrite = (.vwrite + ')')
DEL rbdata.dat
DECLARE c1 CURSOR FOR SELECT &vcols FROM &vtbl &vsuffix
OPEN c1
FETCH c1 INTO &vinto
WHILE SQLCODE <> 100 THEN
  SET VAR v1 TEXT, v2 TEXT, v3 TEXT, v4 TEXT, v5 TEXT
  SET VAR v6 TEXT, v7 TEXT, v8 TEXT, v9 TEXT, v10 TEXT
  &vwrite
  OUTPUT rbdata.dat APPEND
  WRITE .vline
  OUTPUT SCREEN
  FETCH c1 INTO &vinto
ENDWHILE
DROP CURSOR c1
ZIP RETURN +
  c:\wp51\convert rbdata.dat wpdata.mer 9 # {13}{10} {34}
COPY wpdata.mer c:\wp51\docs
CLS
WRITE 'Print' .vfile 'using WPDATA.MER as' +
  'the secondary merge file. Starting WordPerfect...'
PAUSE 1 USING 'Press any key when ready to start WordPerfect'
ZIP RETURN \wp51\wp
LABEL endoc
*( Clear the variables if DEBUG is set OFF.) 
SET VAR vdebug = (CVAL('DEBUG'))
IF vdebug = 'OFF' THEN
  CLEAR VAR vtbl, vcols, vwhr, vline, vwrite, vinto, vcount, vtest, +
    vdesc, vord, vsuffix, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, +
    vi1, vi2, vi3, vi4, vi5, vi6, vi7, vi8, vi9, vi10, vdebug
ENDIF
RETURN

